module Main where

import qualified Test.Storable as Storable
import qualified Test.Vector as Vector

import qualified LLVM.Core as LLVM

import Data.Tuple.HT (mapFst)

import qualified Test.QuickCheck as QC


main :: IO ()
main = do
   LLVM.initializeNativeTarget

   mapM_ (\(msg,prop) -> putStr (msg++": ") >> prop >>= QC.quickCheck) $
      map (mapFst ("Storable."++)) Storable.tests ++
      map (mapFst ("Vector."++)) Vector.tests ++
      []
